## javax.vecmath
Class Tuple3d

    java.lang.Object
      javax.vecmath.Tuple3d

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

Direct Known Subclasses:
  Point3d, Vector3d

    public abstract class Tuple3d

extends java.lang.Object
implements java.io.Serializable, java.lang.Cloneable

A generic 3-element tuple that is represented by double-precision floating point x,y,z coordinates.

See Also:
  Serialized Form

Field Summary
`double` `x` The x coordinate.
`double` `y` The y coordinate.
`double` `z` The z coordinate.

Constructor Summary
`Tuple3d()` Constructs and initializes a Tuple3d to (0,0,0).
`Tuple3d(double[] t)` Constructs and initializes a Tuple3d from the array of length 3.
`Tuple3d(double x, double y, double z)` Constructs and initializes a Tuple3d from the specified xyz coordinates.
`Tuple3d(Tuple3d t1)` Constructs and initializes a Tuple3d from the specified Tuple3d.
`Tuple3d(Tuple3f t1)` Constructs and initializes a Tuple3d from the specified Tuple3f.

Method Summary
`void` `absolute()` Sets each component of this tuple to its absolute value.
`void` `absolute(Tuple3d t)` Sets each component of the tuple parameter to its absolute value and places the modified values into this tuple.
`void` `add(Tuple3d t1)` Sets the value of this tuple to the sum of itself and t1.
`void` `add(Tuple3d t1, Tuple3d t2)` Sets the value of this tuple to the sum of tuples t1 and t2.
`void` `clamp(double min, double max)` Clamps this tuple to the range [low, high].
`void` `clamp(double min, double max, Tuple3d t)` Clamps the tuple parameter to the range [low, high] and places the values into this tuple.
`void` `clamp(float min, float max)` Deprecated. Use clamp(double,double) instead
`void` `clamp(float min, float max, Tuple3d t)` Deprecated. Use clamp(double,double,Tuple3d) instead
`void` `clampMax(double max)` Clamps the maximum value of this tuple to the max parameter.
`void` `clampMax(double max, Tuple3d t)` Clamps the maximum value of the tuple parameter to the max parameter and places the values into this tuple.
`void` `clampMax(float max)` Deprecated. Use clampMax(double) instead
`void` `clampMax(float max, Tuple3d t)` Deprecated. Use clampMax(double,Tuple3d) instead
`void` `clampMin(double min)` Clamps the minimum value of this tuple to the min parameter.
`void` `clampMin(double min, Tuple3d t)` Clamps the minimum value of the tuple parameter to the min parameter and places the values into this tuple.
`void` `clampMin(float min)` Deprecated. Use clampMin(double) instead
`void` `clampMin(float min, Tuple3d t)` Deprecated. Use clampMin(double,Tuple3d) instead
`java.lang.Object` `clone()` Creates a new object of the same class as this object.
`boolean` `epsilonEquals(Tuple3d t1, double epsilon)` Returns true if the L-infinite distance between this tuple and tuple t1 is less than or equal to the epsilon parameter, otherwise returns false.
`boolean` `equals(java.lang.Object t1)` Returns true if the Object t1 is of type Tuple3d and all of the data members of t1 are equal to the corresponding data members in this Tuple3d.
`boolean` `equals(Tuple3d t1)` Returns true if all of the data members of Tuple3d t1 are equal to the corresponding data members in this Tuple3d.
`void` `get(double[] t)` Copies the x,y,z coordinates of this tuple into the array t of length 3.
`void` `get(Tuple3d t)` Copies the x,y,z coordinates of this tuple into the tuple t.
`double` `getX()` Get the x coordinate.
`double` `getY()` Get the y coordinate.
`double` `getZ()` Get the z coordinate.
`int` `hashCode()` Returns a hash code value based on the data values in this object.
`void` `interpolate(Tuple3d t1, double alpha)` Linearly interpolates between this tuple and tuple t1 and places the result into this tuple: this = (1-alpha)*this + alpha*t1.
`void` `interpolate(Tuple3d t1, float alpha)` Deprecated. Use interpolate(Tuple3d,double) instead
`void` `interpolate(Tuple3d t1, Tuple3d t2, double alpha)` Linearly interpolates between tuples t1 and t2 and places the result into this tuple: this = (1-alpha)*t1 + alpha*t2.
`void` `interpolate(Tuple3d t1, Tuple3d t2, float alpha)` Deprecated. Use interpolate(Tuple3d,Tuple3d,double) instead
`void` `negate()` Negates the value of this tuple in place.
`void` `negate(Tuple3d t1)` Sets the value of this tuple to the negation of tuple t1.
`void` `scale(double s)` Sets the value of this tuple to the scalar multiplication of itself.
`void` `scale(double s, Tuple3d t1)` Sets the value of this tuple to the scalar multiplication of tuple t1.
`void` `scaleAdd(double s, Tuple3d t1)` Sets the value of this tuple to the scalar multiplication of itself and then adds tuple t1 (this = s*this + t1).
`void` `scaleAdd(double s, Tuple3d t1, Tuple3d t2)` Sets the value of this tuple to the scalar multiplication of tuple t1 and then adds tuple t2 (this = s*t1 + t2).
`void` `scaleAdd(double s, Tuple3f t1)` Deprecated. Use scaleAdd(double,Tuple3d) instead
`void` `set(double[] t)` Sets the value of this tuple to the value of the xyz coordinates located in the array of length 3.
`void` `set(double x, double y, double z)` Sets the value of this tuple to the specified xyz coordinates.
`void` `set(Tuple3d t1)` Sets the value of this tuple to the value of tuple t1.
`void` `set(Tuple3f t1)` Sets the value of this tuple to the value of tuple t1.
`void` `setX(double x)` Set the x coordinate.
`void` `setY(double y)` Set the y coordinate.
`void` `setZ(double z)` Set the z coordinate.
`void` `sub(Tuple3d t1)` Sets the value of this tuple to the difference of itself and t1 (this = this - t1).
`void` `sub(Tuple3d t1, Tuple3d t2)` Sets the value of this tuple to the difference of tuples t1 and t2 (this = t1 - t2).
`java.lang.String` `toString()` Returns a string that contains the values of this Tuple3d.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### x

    public double x

  The x coordinate.

### y

    public double y

  The y coordinate.

### z

    public double z

  The z coordinate.

Constructor Detail

### Tuple3d

    public Tuple3d(double x,
                   double y,
                   double z)

  Constructs and initializes a Tuple3d from the specified xyz coordinates.

  Parameters:
    `x` - the x coordinate
    `y` - the y coordinate
    `z` - the z coordinate

### Tuple3d

    public Tuple3d(double[] t)

  Constructs and initializes a Tuple3d from the array of length 3.

  Parameters:
    `t` - the array of length 3 containing xyz in order

### Tuple3d

    public Tuple3d(Tuple3d t1)

  Constructs and initializes a Tuple3d from the specified Tuple3d.

  Parameters:
    `t1` - the Tuple3d containing the initialization x y z data

### Tuple3d

    public Tuple3d(Tuple3f t1)

  Constructs and initializes a Tuple3d from the specified Tuple3f.

  Parameters:
    `t1` - the Tuple3f containing the initialization x y z data

### Tuple3d

    public Tuple3d()

  Constructs and initializes a Tuple3d to (0,0,0).

Method Detail

### set

    public final void set(double x,
                          double y,
                          double z)

  Sets the value of this tuple to the specified xyz coordinates.

  Parameters:
    `x` - the x coordinate
    `y` - the y coordinate
    `z` - the z coordinate

### set

    public final void set(double[] t)

  Sets the value of this tuple to the value of the xyz coordinates located in the array of length 3.

  Parameters:
    `t` - the array of length 3 containing xyz in order

### set

    public final void set(Tuple3d t1)

  Sets the value of this tuple to the value of tuple t1.

  Parameters:
    `t1` - the tuple to be copied

### set

    public final void set(Tuple3f t1)

  Sets the value of this tuple to the value of tuple t1.

  Parameters:
    `t1` - the tuple to be copied

### get

    public final void get(double[] t)

  Copies the x,y,z coordinates of this tuple into the array t of length 3.

  Parameters:
    `t` - the target array

### get

    public final void get(Tuple3d t)

  Copies the x,y,z coordinates of this tuple into the tuple t.

  Parameters:
    `t` - the Tuple3d object into which the values of this object are copied

### add

    public final void add(Tuple3d t1,
                          Tuple3d t2)

  Sets the value of this tuple to the sum of tuples t1 and t2.

  Parameters:
    `t1` - the first tuple
    `t2` - the second tuple

### add

    public final void add(Tuple3d t1)

  Sets the value of this tuple to the sum of itself and t1.

  Parameters:
    `t1` - the other tuple

### sub

    public final void sub(Tuple3d t1,
                          Tuple3d t2)

  Sets the value of this tuple to the difference of tuples t1 and t2 (this = t1 - t2).

  Parameters:
    `t1` - the first tuple
    `t2` - the second tuple

### sub

    public final void sub(Tuple3d t1)

  Sets the value of this tuple to the difference of itself and t1 (this = this - t1).

  Parameters:
    `t1` - the other tuple

### negate

    public final void negate(Tuple3d t1)

  Sets the value of this tuple to the negation of tuple t1.

  Parameters:
    `t1` - the source tuple

### negate

    public final void negate()

  Negates the value of this tuple in place.

### scale

    public final void scale(double s,
                            Tuple3d t1)

  Sets the value of this tuple to the scalar multiplication of tuple t1.

  Parameters:
    `s` - the scalar value
    `t1` - the source tuple

### scale

    public final void scale(double s)

  Sets the value of this tuple to the scalar multiplication of itself.

  Parameters:
    `s` - the scalar value

### scaleAdd

    public final void scaleAdd(double s,
                               Tuple3d t1,
                               Tuple3d t2)

  Sets the value of this tuple to the scalar multiplication of tuple t1 and then adds tuple t2 (this = s*t1 + t2).

  Parameters:
    `s` - the scalar value
    `t1` - the tuple to be multipled
    `t2` - the tuple to be added

### scaleAdd

    public final void scaleAdd(double s,
                               Tuple3f t1)

  Deprecated. Use scaleAdd(double,Tuple3d) instead

### scaleAdd

    public final void scaleAdd(double s,
                               Tuple3d t1)

  Sets the value of this tuple to the scalar multiplication of itself and then adds tuple t1 (this = s*this + t1).

  Parameters:
    `s` - the scalar value
    `t1` - the tuple to be added

### toString

    public java.lang.String toString()

  Returns a string that contains the values of this Tuple3d. The form is (x,y,z).

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the String representation

### hashCode

    public int hashCode()

  Returns a hash code value based on the data values in this object. Two different Tuple3d objects with identical data values (i.e., Tuple3d.equals returns true) will return the same hash code value. Two objects with different data members may return the same hash value, although this is not likely.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    the integer hash code value

### equals

    public boolean equals(Tuple3d t1)

  Returns true if all of the data members of Tuple3d t1 are equal to the corresponding data members in this Tuple3d.

  Parameters:
    `t1` - the tuple with which the comparison is made
  Returns:
    true or false

### equals

    public boolean equals(java.lang.Object t1)

  Returns true if the Object t1 is of type Tuple3d and all of the data members of t1 are equal to the corresponding data members in this Tuple3d.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `t1` - the Object with which the comparison is made
  Returns:
    true or false

### epsilonEquals

    public boolean epsilonEquals(Tuple3d t1,
                                 double epsilon)

  Returns true if the L-infinite distance between this tuple and tuple t1 is less than or equal to the epsilon parameter, otherwise returns false. The L-infinite distance is equal to MAX[abs(x1-x2), abs(y1-y2), abs(z1-z2)].

  Parameters:
    `t1` - the tuple to be compared to this tuple
    `epsilon` - the threshold value
  Returns:
    true or false

### clamp

    public final void clamp(float min,
                            float max,
                            Tuple3d t)

  Deprecated. Use clamp(double,double,Tuple3d) instead

### clamp

    public final void clamp(double min,
                            double max,
                            Tuple3d t)

  Clamps the tuple parameter to the range [low, high] and places the values into this tuple.

  Parameters:
    `min` - the lowest value in the tuple after clamping
    `max` - the highest value in the tuple after clamping
    `t` - the source tuple, which will not be modified

### clampMin

    public final void clampMin(float min,
                               Tuple3d t)

  Deprecated. Use clampMin(double,Tuple3d) instead

### clampMin

    public final void clampMin(double min,
                               Tuple3d t)

  Clamps the minimum value of the tuple parameter to the min parameter and places the values into this tuple.

  Parameters:
    `min` - the lowest value in the tuple after clamping
    `t` - the source tuple, which will not be modified

### clampMax

    public final void clampMax(float max,
                               Tuple3d t)

  Deprecated. Use clampMax(double,Tuple3d) instead

### clampMax

    public final void clampMax(double max,
                               Tuple3d t)

  Clamps the maximum value of the tuple parameter to the max parameter and places the values into this tuple.

  Parameters:
    `max` - the highest value in the tuple after clamping
    `t` - the source tuple, which will not be modified

### absolute

    public final void absolute(Tuple3d t)

  Sets each component of the tuple parameter to its absolute value and places the modified values into this tuple.

  Parameters:
    `t` - the source tuple, which will not be modified

### clamp

    public final void clamp(float min,
                            float max)

  Deprecated. Use clamp(double,double) instead

### clamp

    public final void clamp(double min,
                            double max)

  Clamps this tuple to the range [low, high].

  Parameters:
    `min` - the lowest value in this tuple after clamping
    `max` - the highest value in this tuple after clamping

### clampMin

    public final void clampMin(float min)

  Deprecated. Use clampMin(double) instead

### clampMin

    public final void clampMin(double min)

  Clamps the minimum value of this tuple to the min parameter.

  Parameters:
    `min` - the lowest value in this tuple after clamping

### clampMax

    public final void clampMax(float max)

  Deprecated. Use clampMax(double) instead

### clampMax

    public final void clampMax(double max)

  Clamps the maximum value of this tuple to the max parameter.

  Parameters:
    `max` - the highest value in the tuple after clamping

### absolute

    public final void absolute()

  Sets each component of this tuple to its absolute value.

### interpolate

    public final void interpolate(Tuple3d t1,
                                  Tuple3d t2,
                                  float alpha)

  Deprecated. Use interpolate(Tuple3d,Tuple3d,double) instead

### interpolate

    public final void interpolate(Tuple3d t1,
                                  Tuple3d t2,
                                  double alpha)

  Linearly interpolates between tuples t1 and t2 and places the result into this tuple: this = (1-alpha)*t1 + alpha*t2.

  Parameters:
    `t1` - the first tuple
    `t2` - the second tuple
    `alpha` - the alpha interpolation parameter

### interpolate

    public final void interpolate(Tuple3d t1,
                                  float alpha)

  Deprecated. Use interpolate(Tuple3d,double) instead

### interpolate

    public final void interpolate(Tuple3d t1,
                                  double alpha)

  Linearly interpolates between this tuple and tuple t1 and places the result into this tuple: this = (1-alpha)*this + alpha*t1.

  Parameters:
    `t1` - the first tuple
    `alpha` - the alpha interpolation parameter

### clone

    public java.lang.Object clone()

  Creates a new object of the same class as this object.

  Overrides:
    `clone` in class `java.lang.Object`
  Returns:
    a clone of this instance.
  Throws:
    `java.lang.OutOfMemoryError` - if there is not enough memory.
  Since:
    vecmath 1.3
  See Also:
    `Cloneable`

### getX

    public final double getX()

  Get the x coordinate.

  Returns:
    the x coordinate.
  Since:
    vecmath 1.5

### setX

    public final void setX(double x)

  Set the x coordinate.

  Parameters:
    `x` - value to x coordinate.
  Since:
    vecmath 1.5

### getY

    public final double getY()

  Get the y coordinate.

  Returns:
    the y coordinate.
  Since:
    vecmath 1.5

### setY

    public final void setY(double y)

  Set the y coordinate.

  Parameters:
    `y` - value to y coordinate.
  Since:
    vecmath 1.5

### getZ

    public final double getZ()

  Get the z coordinate.

  Returns:
    the z coordinate.
  Since:
    vecmath 1.5

### setZ

    public final void setZ(double z)

  Set the z coordinate.

  Parameters:
    `z` - value to z coordinate.
  Since:
    vecmath 1.5

Copyright 1996-2008 Sun Microsystems, Inc. All Rights Reserved. Use is subject to license terms.